<?php

namespace Drupal\wordfilter\Attribute;

use Drupal\Component\Plugin\Attribute\Plugin;
use Drupal\Core\StringTranslation\TranslatableMarkup;

/**
 * Defines a WordFilterProcess attribute object.
 *
 * Plugin Namespace: Plugin\wordfilter\WordFilterProcess.
 *
 * For a working example, see
 * \Drupal\wordfilter\Plugin\WordfilterProcess\DefaultWordfilterProcess
 *
 * @see \Drupal\wordfilter\WordfilterProcessBase
 * @see \Drupal\wordfilter\WordfilterProcessInterface
 * @see \Drupal\wordfilter\WordfilterProcessManager
 * @see plugin_api
 */
#[\Attribute(\Attribute::TARGET_CLASS)]
class WordFilterProcess extends Plugin {

  /**
   * Constructs a WordFilterProcess attribute.
   *
   * @param string $id
   *   The plugin ID.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $label
   *   The label of the process.
   * @param \Drupal\Core\StringTranslation\TranslatableMarkup|null $description
   *   The description of the process.
   */
  public function __construct(
    public readonly string $id,
    public readonly ?TranslatableMarkup $label = NULL,
    public readonly ?TranslatableMarkup $description = NULL,
  ) {}

}
